Frågar de resurser som hanteras av Azure Resource Manager efter omfång som anges i begäran.
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
URI-parametrar
| Name |
I |
Obligatorisk |
Typ |
Description |
|
api-version
|
query |
True
|
string
minLength: 1
|
DEN API-version som ska användas för den här åtgärden.
|
Begärandetext
| Name |
Obligatorisk |
Typ |
Description |
|
query
|
True
|
string
|
Resursfrågan.
|
|
facets
|
|
FacetRequest[]
|
En matris med fasetteringsbegäranden som ska beräknas mot frågeresultatet.
|
|
managementGroups
|
|
string[]
|
Azure-hanteringsgrupper som frågan ska köras mot. Exempel: [ "mg1", "mg2" ]
|
|
options
|
|
QueryRequestOptions
|
Frågeutvärderingsalternativen
|
|
subscriptions
|
|
string[]
|
Azure-prenumerationer som frågan ska köras mot.
|
Svar
Säkerhet
azure_auth
Azure Active Directory OAuth2 Flow.
Typ:
oauth2
Flow:
implicit
Auktoriseringswebbadress:
https://login.microsoftonline.com/common/oauth2/authorize
Omfattningar
| Name |
Description |
|
user_impersonation
|
personifiera ditt användarkonto
|
Exempel
Access a properties field
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"query": "Resources | where type =~ 'Microsoft.Compute/virtualMachines' | summarize count() by tostring(properties.storageProfile.osDisk.osType)",
"subscriptions": [
"cfbbd179-59d2-4052-aa06-9270a38aa9d6"
]
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesPropertiesQuery.json
func ExampleClient_Resources_accessAPropertiesField() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
Query: to.Ptr("Resources | where type =~ 'Microsoft.Compute/virtualMachines' | summarize count() by tostring(properties.storageProfile.osDisk.osType)"),
Subscriptions: []*string{
to.Ptr("cfbbd179-59d2-4052-aa06-9270a38aa9d6"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// Count: to.Ptr[int64](2),
// Data: []any{
// map[string]any{
// "count": 7,
// "properties_storageProfile_osDisk_osType": "Linux",
// },
// map[string]any{
// "count": 23,
// "properties_storageProfile_osDisk_osType": "Windows",
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](2),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"count": 2,
"data": [
{
"count": 7,
"properties_storageProfile_osDisk_osType": "Linux"
},
{
"count": 23,
"properties_storageProfile_osDisk_osType": "Windows"
}
],
"facets": [],
"resultTruncated": "false",
"totalRecords": 2
}
Basic management group query
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"managementGroups": [
"e927f598-c1d4-4f72-8541-95d83a6a4ac8",
"ProductionMG"
],
"query": "Resources | project id, name, type, location, tags | limit 3"
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesMgBasicQuery.json
func ExampleClient_Resources_basicManagementGroupQuery() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
ManagementGroups: []*string{
to.Ptr("e927f598-c1d4-4f72-8541-95d83a6a4ac8"),
to.Ptr("ProductionMG"),
},
Query: to.Ptr("Resources | project id, name, type, location, tags | limit 3"),
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// Count: to.Ptr[int64](3),
// Data: []any{
// map[string]any{
// "name": "myNetworkInterface",
// "type": "microsoft.network/networkinterfaces",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Network/networkInterfaces/myNetworkInterface",
// "location": "centralus",
// "tags": map[string]any{
// "tag1": "Value1",
// },
// },
// map[string]any{
// "name": "myVnet",
// "type": "microsoft.network/virtualnetworks",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/virtualNetworks/myVnet",
// "location": "westus",
// "tags": map[string]any{
// },
// },
// map[string]any{
// "name": "myPublicIp",
// "type": "microsoft.network/publicipaddresses",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/publicIPAddresses/myPublicIp",
// "location": "westus",
// "tags": map[string]any{
// },
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](3),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"count": 3,
"data": [
{
"name": "myNetworkInterface",
"type": "microsoft.network/networkinterfaces",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Network/networkInterfaces/myNetworkInterface",
"location": "centralus",
"tags": {
"tag1": "Value1"
}
},
{
"name": "myVnet",
"type": "microsoft.network/virtualnetworks",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/virtualNetworks/myVnet",
"location": "westus",
"tags": {}
},
{
"name": "myPublicIp",
"type": "microsoft.network/publicipaddresses",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/publicIPAddresses/myPublicIp",
"location": "westus",
"tags": {}
}
],
"facets": [],
"resultTruncated": "false",
"totalRecords": 3
}
Basic query
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"query": "Resources | project id, name, type, location, tags | limit 3",
"subscriptions": [
"cfbbd179-59d2-4052-aa06-9270a38aa9d6"
]
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesBasicQuery.json
func ExampleClient_Resources_basicQuery() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
Query: to.Ptr("Resources | project id, name, type, location, tags | limit 3"),
Subscriptions: []*string{
to.Ptr("cfbbd179-59d2-4052-aa06-9270a38aa9d6"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// Count: to.Ptr[int64](3),
// Data: []any{
// map[string]any{
// "name": "myNetworkInterface",
// "type": "microsoft.network/networkinterfaces",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Network/networkInterfaces/myNetworkInterface",
// "location": "centralus",
// "tags": map[string]any{
// "tag1": "Value1",
// },
// },
// map[string]any{
// "name": "myVnet",
// "type": "microsoft.network/virtualnetworks",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/virtualNetworks/myVnet",
// "location": "westus",
// "tags": map[string]any{
// },
// },
// map[string]any{
// "name": "myPublicIp",
// "type": "microsoft.network/publicipaddresses",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/publicIPAddresses/myPublicIp",
// "location": "westus",
// "tags": map[string]any{
// },
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](3),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"count": 3,
"data": [
{
"name": "myNetworkInterface",
"type": "microsoft.network/networkinterfaces",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Network/networkInterfaces/myNetworkInterface",
"location": "centralus",
"tags": {
"tag1": "Value1"
}
},
{
"name": "myVnet",
"type": "microsoft.network/virtualnetworks",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/virtualNetworks/myVnet",
"location": "westus",
"tags": {}
},
{
"name": "myPublicIp",
"type": "microsoft.network/publicipaddresses",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/publicIPAddresses/myPublicIp",
"location": "westus",
"tags": {}
}
],
"facets": [],
"resultTruncated": "false",
"totalRecords": 3
}
Basic tenant query
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"query": "Resources | project id, name, type, location, tags | limit 3"
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesTenantBasicQuery.json
func ExampleClient_Resources_basicTenantQuery() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
Query: to.Ptr("Resources | project id, name, type, location, tags | limit 3"),
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// Count: to.Ptr[int64](3),
// Data: []any{
// map[string]any{
// "name": "myNetworkInterface",
// "type": "microsoft.network/networkinterfaces",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Network/networkInterfaces/myNetworkInterface",
// "location": "centralus",
// "tags": map[string]any{
// "tag1": "Value1",
// },
// },
// map[string]any{
// "name": "myVnet",
// "type": "microsoft.network/virtualnetworks",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/virtualNetworks/myVnet",
// "location": "westus",
// "tags": map[string]any{
// },
// },
// map[string]any{
// "name": "myPublicIp",
// "type": "microsoft.network/publicipaddresses",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/publicIPAddresses/myPublicIp",
// "location": "westus",
// "tags": map[string]any{
// },
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](3),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"count": 3,
"data": [
{
"name": "myNetworkInterface",
"type": "microsoft.network/networkinterfaces",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Network/networkInterfaces/myNetworkInterface",
"location": "centralus",
"tags": {
"tag1": "Value1"
}
},
{
"name": "myVnet",
"type": "microsoft.network/virtualnetworks",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/virtualNetworks/myVnet",
"location": "westus",
"tags": {}
},
{
"name": "myPublicIp",
"type": "microsoft.network/publicipaddresses",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Network/publicIPAddresses/myPublicIp",
"location": "westus",
"tags": {}
}
],
"facets": [],
"resultTruncated": "false",
"totalRecords": 3
}
Complex query
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"query": "Resources | project id, name, type, location | where type =~ 'Microsoft.Compute/virtualMachines' | summarize count() by location | top 3 by count_",
"subscriptions": [
"cfbbd179-59d2-4052-aa06-9270a38aa9d6"
]
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesComplexQuery.json
func ExampleClient_Resources_complexQuery() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
Query: to.Ptr("Resources | project id, name, type, location | where type =~ 'Microsoft.Compute/virtualMachines' | summarize count() by location | top 3 by count_"),
Subscriptions: []*string{
to.Ptr("cfbbd179-59d2-4052-aa06-9270a38aa9d6"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// Count: to.Ptr[int64](3),
// Data: []any{
// map[string]any{
// "count_": 11,
// "location": "centralus",
// },
// map[string]any{
// "count_": 11,
// "location": "eastus",
// },
// map[string]any{
// "count_": 3,
// "location": "southcentralus",
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](3),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"count": 3,
"data": [
{
"count_": 11,
"location": "centralus"
},
{
"count_": 11,
"location": "eastus"
},
{
"count_": 3,
"location": "southcentralus"
}
],
"facets": [],
"resultTruncated": "false",
"totalRecords": 3
}
Filter resources
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"query": "Resources | project id, name, type, location | where type =~ 'Microsoft.Compute/virtualMachines' | limit 3",
"subscriptions": [
"cfbbd179-59d2-4052-aa06-9270a38aa9d6"
]
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesFilterQuery.json
func ExampleClient_Resources_filterResources() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
Query: to.Ptr("Resources | project id, name, type, location | where type =~ 'Microsoft.Compute/virtualMachines' | limit 3"),
Subscriptions: []*string{
to.Ptr("cfbbd179-59d2-4052-aa06-9270a38aa9d6"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// Count: to.Ptr[int64](3),
// Data: []any{
// map[string]any{
// "name": "myVm1",
// "type": "microsoft.compute/virtualmachines",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Compute/virtualMachines/myVm1",
// "location": "centralus",
// },
// map[string]any{
// "name": "myVirtualMachine",
// "type": "microsoft.compute/virtualmachines",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Compute/virtualMachines/myVirtualMachine",
// "location": "eastus",
// },
// map[string]any{
// "name": "testVm",
// "type": "microsoft.compute/virtualmachines",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG3/providers/Microsoft.Compute/virtualMachines/testVm",
// "location": "eastus",
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](3),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"count": 3,
"data": [
{
"name": "myVm1",
"type": "microsoft.compute/virtualmachines",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Compute/virtualMachines/myVm1",
"location": "centralus"
},
{
"name": "myVirtualMachine",
"type": "microsoft.compute/virtualmachines",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Compute/virtualMachines/myVirtualMachine",
"location": "eastus"
},
{
"name": "testVm",
"type": "microsoft.compute/virtualmachines",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG3/providers/Microsoft.Compute/virtualMachines/testVm",
"location": "eastus"
}
],
"facets": [],
"resultTruncated": "false",
"totalRecords": 3
}
First page query
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"options": {
"$skip": 0,
"$top": 3
},
"query": "Resources | where name contains 'test' | project id, name, type, location",
"subscriptions": [
"cfbbd179-59d2-4052-aa06-9270a38aa9d6"
]
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesFirstPageQuery.json
func ExampleClient_Resources_firstPageQuery() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
Options: &armresourcegraph.QueryRequestOptions{
Skip: to.Ptr[int32](0),
Top: to.Ptr[int32](3),
},
Query: to.Ptr("Resources | where name contains 'test' | project id, name, type, location"),
Subscriptions: []*string{
to.Ptr("cfbbd179-59d2-4052-aa06-9270a38aa9d6"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// SkipToken: to.Ptr("eyAibm8iOiAibHVjayIsICJidXQiOiAibmljZSIsICJ0cnkiOiAiISIgfQ=="),
// Count: to.Ptr[int64](3),
// Data: []any{
// map[string]any{
// "name": "yetanothertest_OsDisk_1_f396cbcb625a457bb69fe2abf5975820",
// "type": "microsoft.compute/disks",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Compute/disks/yetanothertest_OsDisk_1_f396cbcb625a457bb69fe2abf5975820",
// "location": "eastus",
// },
// map[string]any{
// "name": "TestAA",
// "type": "microsoft.automation/automationaccounts",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Automation/automationAccounts/TestAA",
// "location": "westcentralus",
// },
// map[string]any{
// "name": "TestRB",
// "type": "microsoft.automation/automationaccounts/runbooks",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Automation/automationAccounts/TestAA/runbooks/TestRB",
// "location": "westcentralus",
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](386),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"$skipToken": "eyAibm8iOiAibHVjayIsICJidXQiOiAibmljZSIsICJ0cnkiOiAiISIgfQ==",
"count": 3,
"data": [
{
"name": "yetanothertest_OsDisk_1_f396cbcb625a457bb69fe2abf5975820",
"type": "microsoft.compute/disks",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Compute/disks/yetanothertest_OsDisk_1_f396cbcb625a457bb69fe2abf5975820",
"location": "eastus"
},
{
"name": "TestAA",
"type": "microsoft.automation/automationaccounts",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Automation/automationAccounts/TestAA",
"location": "westcentralus"
},
{
"name": "TestRB",
"type": "microsoft.automation/automationaccounts/runbooks",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Automation/automationAccounts/TestAA/runbooks/TestRB",
"location": "westcentralus"
}
],
"facets": [],
"resultTruncated": "false",
"totalRecords": 386
}
Next page query
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"options": {
"$skipToken": "eyAibm8iOiAibHVjayIsICJidXQiOiAibmljZSIsICJ0cnkiOiAiISIgfQ=="
},
"query": "Resources | where name contains 'test' | project id, name, type, location",
"subscriptions": [
"cfbbd179-59d2-4052-aa06-9270a38aa9d6"
]
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesNextPageQuery.json
func ExampleClient_Resources_nextPageQuery() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
Options: &armresourcegraph.QueryRequestOptions{
SkipToken: to.Ptr("eyAibm8iOiAibHVjayIsICJidXQiOiAibmljZSIsICJ0cnkiOiAiISIgfQ=="),
},
Query: to.Ptr("Resources | where name contains 'test' | project id, name, type, location"),
Subscriptions: []*string{
to.Ptr("cfbbd179-59d2-4052-aa06-9270a38aa9d6"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// SkipToken: to.Ptr("eyAibm8yIjogImx1Y2syIiwgImJ1dDIiOiAibmljZTIiLCAidHJ5MiI6ICIhIiB9"),
// Count: to.Ptr[int64](3),
// Data: []any{
// map[string]any{
// "name": "second_OsDisk_dddddbcb625a457bb69fe2abf5975820",
// "type": "microsoft.compute/disks",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Compute/disks/second_OsDisk_dddddbcb625a457bb69fe2abf5975820",
// "location": "eastus",
// },
// map[string]any{
// "name": "AATest",
// "type": "microsoft.automation/automationaccounts",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Automation/automationAccounts/AATest",
// "location": "westcentralus",
// },
// map[string]any{
// "name": "RBTest",
// "type": "microsoft.automation/automationaccounts/runbooks",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Automation/automationAccounts/TestAA/runbooks/RBTest",
// "location": "westcentralus",
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](386),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"$skipToken": "eyAibm8yIjogImx1Y2syIiwgImJ1dDIiOiAibmljZTIiLCAidHJ5MiI6ICIhIiB9",
"count": 3,
"data": [
{
"name": "second_OsDisk_dddddbcb625a457bb69fe2abf5975820",
"type": "microsoft.compute/disks",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Compute/disks/second_OsDisk_dddddbcb625a457bb69fe2abf5975820",
"location": "eastus"
},
{
"name": "AATest",
"type": "microsoft.automation/automationaccounts",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Automation/automationAccounts/AATest",
"location": "westcentralus"
},
{
"name": "RBTest",
"type": "microsoft.automation/automationaccounts/runbooks",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Automation/automationAccounts/TestAA/runbooks/RBTest",
"location": "westcentralus"
}
],
"facets": [],
"resultTruncated": "false",
"totalRecords": 386
}
Query with a facet request
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"facets": [
{
"expression": "location",
"options": {
"$top": 3,
"sortOrder": "desc"
}
},
{
"expression": "properties.storageProfile.osDisk.osType",
"options": {
"$top": 3,
"sortOrder": "desc"
}
},
{
"expression": "nonExistingColumn",
"options": {
"$top": 3,
"sortOrder": "desc"
}
},
{
"expression": "resourceGroup",
"options": {
"$top": 3,
"sortBy": "tolower(resourceGroup)",
"sortOrder": "asc"
}
},
{
"expression": "resourceGroup",
"options": {
"$top": 3,
"filter": "resourceGroup contains 'test'"
}
}
],
"query": "Resources | where type =~ 'Microsoft.Compute/virtualMachines' | project id, name, location, resourceGroup, properties.storageProfile.osDisk.osType | limit 5",
"subscriptions": [
"cfbbd179-59d2-4052-aa06-9270a38aa9d6"
]
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesFacetQuery.json
func ExampleClient_Resources_queryWithAFacetRequest() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
Facets: []*armresourcegraph.FacetRequest{
{
Expression: to.Ptr("location"),
Options: &armresourcegraph.FacetRequestOptions{
Top: to.Ptr[int32](3),
SortOrder: to.Ptr(armresourcegraph.FacetSortOrderDesc),
},
},
{
Expression: to.Ptr("properties.storageProfile.osDisk.osType"),
Options: &armresourcegraph.FacetRequestOptions{
Top: to.Ptr[int32](3),
SortOrder: to.Ptr(armresourcegraph.FacetSortOrderDesc),
},
},
{
Expression: to.Ptr("nonExistingColumn"),
Options: &armresourcegraph.FacetRequestOptions{
Top: to.Ptr[int32](3),
SortOrder: to.Ptr(armresourcegraph.FacetSortOrderDesc),
},
},
{
Expression: to.Ptr("resourceGroup"),
Options: &armresourcegraph.FacetRequestOptions{
Top: to.Ptr[int32](3),
SortBy: to.Ptr("tolower(resourceGroup)"),
SortOrder: to.Ptr(armresourcegraph.FacetSortOrderAsc),
},
},
{
Expression: to.Ptr("resourceGroup"),
Options: &armresourcegraph.FacetRequestOptions{
Top: to.Ptr[int32](3),
Filter: to.Ptr("resourceGroup contains 'test'"),
},
},
},
Query: to.Ptr("Resources | where type =~ 'Microsoft.Compute/virtualMachines' | project id, name, location, resourceGroup, properties.storageProfile.osDisk.osType | limit 5"),
Subscriptions: []*string{
to.Ptr("cfbbd179-59d2-4052-aa06-9270a38aa9d6"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// Count: to.Ptr[int64](5),
// Data: []any{
// map[string]any{
// "name": "myTestVm",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/B-TEST-RG/providers/Microsoft.Compute/virtualMachines/myTestVm",
// "location": "eastus",
// "properties_storageProfile_osDisk_osType": "Windows",
// "resourceGroup": "B-TEST-RG",
// },
// map[string]any{
// "name": "myTestAccountVm",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/c-rg/providers/Microsoft.Compute/virtualMachines/myTestAccountVm",
// "location": "westcentralus",
// "properties_storageProfile_osDisk_osType": "Windows",
// "resourceGroup": "c-rg",
// },
// map[string]any{
// "name": "yetanothertest",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/I-RG/providers/Microsoft.Compute/virtualMachines/yetanothertest",
// "location": "eastus",
// "properties_storageProfile_osDisk_osType": "Linux",
// "resourceGroup": "I-RG",
// },
// map[string]any{
// "name": "drafttest1bux4cv7a7q3aw",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/x-test-rg/providers/Microsoft.Compute/virtualMachines/drafttest1bux4cv7a7q3aw",
// "location": "southcentralus",
// "properties_storageProfile_osDisk_osType": "Linux",
// "resourceGroup": "x-test-rg",
// },
// map[string]any{
// "name": "testvmntp25370",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/y-rg/providers/Microsoft.Compute/virtualMachines/testvmntp25370",
// "location": "eastus",
// "properties_storageProfile_osDisk_osType": "Windows",
// "resourceGroup": "y-rg",
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// &armresourcegraph.FacetResult{
// Count: to.Ptr[int32](3),
// Data: []any{
// map[string]any{
// "count": 3,
// "location": "eastus",
// },
// map[string]any{
// "count": 1,
// "location": "southcentralus",
// },
// map[string]any{
// "count": 1,
// "location": "westcentralus",
// },
// },
// Expression: to.Ptr("location"),
// ResultType: to.Ptr("FacetResult"),
// TotalRecords: to.Ptr[int64](3),
// },
// &armresourcegraph.FacetResult{
// Count: to.Ptr[int32](2),
// Data: []any{
// map[string]any{
// "count": 2,
// "properties_storageProfile_osDisk_osType": "Linux",
// },
// map[string]any{
// "count": 3,
// "properties_storageProfile_osDisk_osType": "Windows",
// },
// },
// Expression: to.Ptr("properties.storageProfile.osDisk.osType"),
// ResultType: to.Ptr("FacetResult"),
// TotalRecords: to.Ptr[int64](2),
// },
// &armresourcegraph.FacetError{
// Errors: []*armresourcegraph.ErrorDetails{
// {
// Code: to.Ptr("NoValidColumns"),
// Message: to.Ptr("No valid columns in facet expression."),
// },
// {
// Code: to.Ptr("InvalidColumnNames"),
// Message: to.Ptr("Invalid column names: [nonExistingColumn]."),
// },
// },
// Expression: to.Ptr("nonExistingColumn"),
// ResultType: to.Ptr("FacetError"),
// },
// &armresourcegraph.FacetResult{
// Count: to.Ptr[int32](3),
// Data: []any{
// map[string]any{
// "count": 1,
// "resourceGroup": "B-TEST-RG",
// },
// map[string]any{
// "count": 1,
// "resourceGroup": "c-rg",
// },
// map[string]any{
// "count": 1,
// "resourceGroup": "I-RG",
// },
// },
// Expression: to.Ptr("resourceGroup"),
// ResultType: to.Ptr("FacetResult"),
// TotalRecords: to.Ptr[int64](5),
// },
// &armresourcegraph.FacetResult{
// Count: to.Ptr[int32](2),
// Data: []any{
// map[string]any{
// "count": 1,
// "resourceGroup": "B-TEST-RG",
// },
// map[string]any{
// "count": 1,
// "resourceGroup": "x-test-rg",
// },
// },
// Expression: to.Ptr("resourceGroup"),
// ResultType: to.Ptr("FacetResult"),
// TotalRecords: to.Ptr[int64](2),
// },
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](5),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"count": 5,
"data": [
{
"name": "myTestVm",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/B-TEST-RG/providers/Microsoft.Compute/virtualMachines/myTestVm",
"location": "eastus",
"properties_storageProfile_osDisk_osType": "Windows",
"resourceGroup": "B-TEST-RG"
},
{
"name": "myTestAccountVm",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/c-rg/providers/Microsoft.Compute/virtualMachines/myTestAccountVm",
"location": "westcentralus",
"properties_storageProfile_osDisk_osType": "Windows",
"resourceGroup": "c-rg"
},
{
"name": "yetanothertest",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/I-RG/providers/Microsoft.Compute/virtualMachines/yetanothertest",
"location": "eastus",
"properties_storageProfile_osDisk_osType": "Linux",
"resourceGroup": "I-RG"
},
{
"name": "drafttest1bux4cv7a7q3aw",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/x-test-rg/providers/Microsoft.Compute/virtualMachines/drafttest1bux4cv7a7q3aw",
"location": "southcentralus",
"properties_storageProfile_osDisk_osType": "Linux",
"resourceGroup": "x-test-rg"
},
{
"name": "testvmntp25370",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/y-rg/providers/Microsoft.Compute/virtualMachines/testvmntp25370",
"location": "eastus",
"properties_storageProfile_osDisk_osType": "Windows",
"resourceGroup": "y-rg"
}
],
"facets": [
{
"count": 3,
"data": [
{
"count": 3,
"location": "eastus"
},
{
"count": 1,
"location": "southcentralus"
},
{
"count": 1,
"location": "westcentralus"
}
],
"expression": "location",
"resultType": "FacetResult",
"totalRecords": 3
},
{
"count": 2,
"data": [
{
"count": 2,
"properties_storageProfile_osDisk_osType": "Linux"
},
{
"count": 3,
"properties_storageProfile_osDisk_osType": "Windows"
}
],
"expression": "properties.storageProfile.osDisk.osType",
"resultType": "FacetResult",
"totalRecords": 2
},
{
"errors": [
{
"code": "NoValidColumns",
"message": "No valid columns in facet expression."
},
{
"code": "InvalidColumnNames",
"message": "Invalid column names: [nonExistingColumn]."
}
],
"expression": "nonExistingColumn",
"resultType": "FacetError"
},
{
"count": 3,
"data": [
{
"count": 1,
"resourceGroup": "B-TEST-RG"
},
{
"count": 1,
"resourceGroup": "c-rg"
},
{
"count": 1,
"resourceGroup": "I-RG"
}
],
"expression": "resourceGroup",
"resultType": "FacetResult",
"totalRecords": 5
},
{
"count": 2,
"data": [
{
"count": 1,
"resourceGroup": "B-TEST-RG"
},
{
"count": 1,
"resourceGroup": "x-test-rg"
}
],
"expression": "resourceGroup",
"resultType": "FacetResult",
"totalRecords": 2
}
],
"resultTruncated": "false",
"totalRecords": 5
}
Random page query
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"options": {
"$skip": 10,
"$top": 2
},
"query": "Resources | where name contains 'test' | project id, name, type, location",
"subscriptions": [
"cfbbd179-59d2-4052-aa06-9270a38aa9d6"
]
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesRandomPageQuery.json
func ExampleClient_Resources_randomPageQuery() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
Options: &armresourcegraph.QueryRequestOptions{
Skip: to.Ptr[int32](10),
Top: to.Ptr[int32](2),
},
Query: to.Ptr("Resources | where name contains 'test' | project id, name, type, location"),
Subscriptions: []*string{
to.Ptr("cfbbd179-59d2-4052-aa06-9270a38aa9d6"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// SkipToken: to.Ptr("eyAibm8iOiAibHVjayIsICJidXQiOiAibmljZSIsICJ0cnkiOiAiISIgfQ=="),
// Count: to.Ptr[int64](2),
// Data: []any{
// map[string]any{
// "name": "third_OsDisk_dddddbcb625a457bb69fe2abf5975820",
// "type": "microsoft.compute/disks",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Compute/disks/third_OsDisk_dddddbcb625a457bb69fe2abf5975820",
// "location": "eastus",
// },
// map[string]any{
// "name": "CCTest",
// "type": "microsoft.automation/automationaccounts",
// "id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Automation/automationAccounts/CCTest",
// "location": "westcentralus",
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](386),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"$skipToken": "eyAibm8iOiAibHVjayIsICJidXQiOiAibmljZSIsICJ0cnkiOiAiISIgfQ==",
"count": 2,
"data": [
{
"name": "third_OsDisk_dddddbcb625a457bb69fe2abf5975820",
"type": "microsoft.compute/disks",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG1/providers/Microsoft.Compute/disks/third_OsDisk_dddddbcb625a457bb69fe2abf5975820",
"location": "eastus"
},
{
"name": "CCTest",
"type": "microsoft.automation/automationaccounts",
"id": "/subscriptions/cfbbd179-59d2-4052-aa06-9270a38aa9d6/resourceGroups/RG2/providers/Microsoft.Automation/automationAccounts/CCTest",
"location": "westcentralus"
}
],
"facets": [],
"resultTruncated": "false",
"totalRecords": 386
}
Summarize resources by location
Exempelbegäran
POST https://management.azure.com/providers/Microsoft.ResourceGraph/resources?api-version=2024-04-01
{
"query": "Resources | project id, name, type, location | summarize by location",
"subscriptions": [
"cfbbd179-59d2-4052-aa06-9270a38aa9d6"
]
}
package armresourcegraph_test
import (
"context"
"log"
"github.com/Azure/azure-sdk-for-go/sdk/azcore/to"
"github.com/Azure/azure-sdk-for-go/sdk/azidentity"
"github.com/Azure/azure-sdk-for-go/sdk/resourcemanager/resourcegraph/armresourcegraph"
)
// Generated from example definition: 2024-04-01/ResourcesSummarizeQuery.json
func ExampleClient_Resources_summarizeResourcesByLocation() {
cred, err := azidentity.NewDefaultAzureCredential(nil)
if err != nil {
log.Fatalf("failed to obtain a credential: %v", err)
}
ctx := context.Background()
clientFactory, err := armresourcegraph.NewClientFactory(cred, nil)
if err != nil {
log.Fatalf("failed to create client: %v", err)
}
res, err := clientFactory.NewClient().Resources(ctx, armresourcegraph.QueryRequest{
Query: to.Ptr("Resources | project id, name, type, location | summarize by location"),
Subscriptions: []*string{
to.Ptr("cfbbd179-59d2-4052-aa06-9270a38aa9d6"),
},
}, nil)
if err != nil {
log.Fatalf("failed to finish the request: %v", err)
}
// You could use response here. We use blank identifier for just demo purposes.
_ = res
// If the HTTP response code is 200 as defined in example definition, your response structure would look as follows. Please pay attention that all the values in the output are fake values for just demo purposes.
// res = armresourcegraph.ClientResourcesResponse{
// QueryResponse: armresourcegraph.QueryResponse{
// Count: to.Ptr[int64](3),
// Data: []any{
// map[string]any{
// "location": "centralus",
// },
// map[string]any{
// "location": "eastus",
// },
// map[string]any{
// "location": "westus",
// },
// },
// Facets: []armresourcegraph.FacetClassification{
// },
// ResultTruncated: to.Ptr(armresourcegraph.ResultTruncatedFalse),
// TotalRecords: to.Ptr[int64](3),
// },
// }
}
To use the Azure SDK library in your project, see this documentation. To provide feedback on this code sample, open a GitHub issue
Exempelsvar
{
"count": 3,
"data": [
{
"location": "centralus"
},
{
"location": "eastus"
},
{
"location": "westus"
}
],
"facets": [],
"resultTruncated": "false",
"totalRecords": 3
}
Definitioner
AuthorizationScopeFilter
Uppräkning
Definierar vilken nivå av auktoriseringsresurser som ska returneras baserat på vilka prenumerationer och hanteringsgrupper som skickas som omfång.
| Värde |
Description |
|
AtScopeAndBelow
|
AtScopeAndBelow
|
|
AtScopeAndAbove
|
AtScopeAndAbove
|
|
AtScopeExact
|
AtScopeExact
|
|
AtScopeAboveAndBelow
|
AtScopeAboveAndBelow
|
FacetError
Objekt
En aspekt vars körning resulterade i ett fel.
| Name |
Typ |
Description |
|
errors
|
ResourceGraphCommon.ErrorDetails[]
|
En matris som innehåller identifierade fasetteringsfel med information.
|
|
expression
|
string
|
Fasetteringsuttryck, samma som i motsvarande fasetteringsförfrågan.
|
|
resultType
|
string:
FacetError
|
Resultattyp
|
FacetRequest
Objekt
En begäran om att beräkna ytterligare statistik (fasetter) över frågeresultaten.
| Name |
Typ |
Description |
|
expression
|
string
|
Kolumnen eller listan med kolumner som ska sammanfattas av
|
|
options
|
FacetRequestOptions
|
Alternativen för fasetteringsutvärdering
|
FacetRequestOptions
Objekt
Alternativen för fasetteringsutvärdering
| Name |
Typ |
Standardvärde |
Description |
|
$top
|
integer
(int32)
minimum: 1 maximum: 1000
|
|
Det maximala antalet fasetterade rader som ska returneras.
|
|
filter
|
string
|
|
Anger filtervillkoret för "where"-satsen som ska köras på huvudfrågans resultat, precis före den faktiska faseringen.
|
|
sortBy
|
string
|
|
Kolumnnamnet eller frågeuttrycket som ska sorteras. Standardvärdet är att räkna om det inte finns.
|
|
sortOrder
|
FacetSortOrder
|
desc
|
Sorteringsordningen efter den valda kolumnen (antal som standard).
|
FacetResult
Objekt
Fasettering har körts som innehåller ytterligare statistik om svaret på en fråga.
| Name |
Typ |
Description |
|
count
|
integer
(int32)
|
Antal poster som returneras i fasetteringssvaret.
|
|
data
|
|
En JObject-matris eller tabell som innehåller önskade fasetter. Presentera endast om aspekten är giltig.
|
|
expression
|
string
|
Fasetteringsuttryck, samma som i motsvarande fasetteringsförfrågan.
|
|
resultType
|
string:
FacetResult
|
Resultattyp
|
|
totalRecords
|
integer
(int64)
|
Antal totala poster i fasetteringsresultatet.
|
FacetSortOrder
Uppräkning
Sorteringsordningen efter den valda kolumnen (antal som standard).
| Värde |
Description |
|
asc
|
Asc
|
|
desc
|
beskrivning
|
QueryRequest
Objekt
Beskriver en fråga som ska köras.
| Name |
Typ |
Description |
|
facets
|
FacetRequest[]
|
En matris med fasetteringsbegäranden som ska beräknas mot frågeresultatet.
|
|
managementGroups
|
string[]
|
Azure-hanteringsgrupper som frågan ska köras mot. Exempel: [ "mg1", "mg2" ]
|
|
options
|
QueryRequestOptions
|
Frågeutvärderingsalternativen
|
|
query
|
string
|
Resursfrågan.
|
|
subscriptions
|
string[]
|
Azure-prenumerationer som frågan ska köras mot.
|
QueryRequestOptions
Objekt
Alternativen för frågeutvärdering
| Name |
Typ |
Standardvärde |
Description |
|
$skip
|
integer
(int32)
minimum: 0
|
|
Antalet rader som ska hoppa över från början av resultatet. Åsidosätter nästa sidförskjutning när $skipToken egenskapen finns.
|
|
$skipToken
|
string
|
|
Fortsättningstoken för sidnumrering, insamling av nästa sidstorlek och förskjutning samt frågans kontext.
|
|
$top
|
integer
(int32)
minimum: 1 maximum: 1000
|
|
Det maximala antalet rader som frågan ska returnera. Åsidosätter sidstorleken när $skipToken egenskap finns.
|
|
allowPartialScopes
|
boolean
|
False
|
Gäller endast för frågor på klient- och hanteringsgruppsnivå för att avgöra om partiella omfång för resultat ska tillåtas om antalet prenumerationer överskrider tillåtna gränser.
|
|
authorizationScopeFilter
|
AuthorizationScopeFilter
|
AtScopeAndBelow
|
Definierar vilken nivå av auktoriseringsresurser som ska returneras baserat på vilka prenumerationer och hanteringsgrupper som skickas som omfång.
|
|
resultFormat
|
ResultFormat
|
objectArray
|
Definierar i vilket format frågeresultatet returnerades.
|
QueryResponse
Objekt
Frågeresultat.
| Name |
Typ |
Description |
|
$skipToken
|
string
|
I nuläget kan värdet skickas till ett efterföljande frågeanrop (tillsammans med samma fråga och omfång som används i den aktuella begäran) för att hämta nästa sida med data.
|
|
count
|
integer
(int64)
|
Antal poster som returneras i det aktuella svaret. När det gäller växling är det här antalet poster på den aktuella sidan.
|
|
data
|
|
Frågeutdata i JObject-matris eller tabellformat.
|
|
facets
|
Facet[]:
|
Frågefasetter.
|
|
resultTruncated
|
ResultTruncated
|
Anger om frågeresultatet trunkeras.
|
|
totalRecords
|
integer
(int64)
|
Antal poster som matchar frågan.
|
ResourceGraphCommon.Error
Objekt
Felinformation.
| Name |
Typ |
Description |
|
code
|
string
|
Felkod som identifierar det specifika felet.
|
|
details
|
ResourceGraphCommon.ErrorDetails[]
|
Felinformation
|
|
message
|
string
|
Ett mänskligt läsbart felmeddelande.
|
ResourceGraphCommon.ErrorDetails
Objekt
Felinformation.
| Name |
Typ |
Description |
|
code
|
string
|
Felkod som identifierar det specifika felet.
|
|
message
|
string
|
Ett mänskligt läsbart felmeddelande.
|
ResourceGraphCommon.ErrorResponse
Objekt
Felsvar.
Uppräkning
Definierar i vilket format frågeresultatet returnerades.
| Värde |
Description |
|
table
|
table
|
|
objectArray
|
objectArray
|
ResultTruncated
Uppräkning
Anger om frågeresultatet trunkeras.
| Värde |
Description |
|
true
|
sann
|
|
false
|
falsk
|